"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var core_1 = require("@emotion/core");
var canvas_kit_react_common_1 = require("@workday/canvas-kit-react-common");
var Tabs_1 = require("./Tabs");
var styles = core_1.css(canvas_kit_react_common_1.mouseFocusBehavior({
    '&:focus': {
        outline: 'none',
    },
}));
exports.TabPanel = canvas_kit_react_common_1.createComponent('div')({
    displayName: 'Tabs.Panel',
    Component: function (_a, ref, Element) {
        var children = _a.children, _b = _a.name, name = _b === void 0 ? '' : _b, model = _a.model, elemProps = __rest(_a, ["children", "name", "model"]);
        var _c = canvas_kit_react_common_1.useModelContext(Tabs_1.TabsModelContext, model), state = _c.state, events = _c.events;
        var _d = react_1.default.useState(name), tabName = _d[0], setTabName = _d[1];
        var _e = canvas_kit_react_common_1.useLocalRef(ref), localRef = _e.localRef, elementRef = _e.elementRef;
        canvas_kit_react_common_1.useMountLayout(function () {
            var index = state.panelIndexRef.current;
            var tabName = name || String(index);
            events.registerPanel({ item: { id: tabName, ref: localRef } });
            setTabName(tabName);
            return function () {
                events.unregisterItem({ id: tabName });
            };
        });
        return (core_1.jsx(Element, __assign({ ref: elementRef, role: "tabpanel", css: styles, "aria-labelledby": "tab-" + state.id + "-" + tabName, hidden: !!tabName && tabName !== state.activeTab, id: "tabpanel-" + state.id + "-" + tabName, tabIndex: 0 }, elemProps), children));
    },
});
