"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var canvas_kit_react_common_1 = require("@workday/canvas-kit-react-common");
var Tab_1 = require("./Tab");
var TabList_1 = require("./TabList");
var TabPanel_1 = require("./TabPanel");
var useTabsModel_1 = require("./useTabsModel");
exports.TabsModelContext = react_1.default.createContext({});
exports.Tabs = canvas_kit_react_common_1.createComponent()({
    displayName: 'Tabs',
    Component: function (_a) {
        var children = _a.children, model = _a.model, config = __rest(_a, ["children", "model"]);
        var value = canvas_kit_react_common_1.useDefaultModel(model, config, useTabsModel_1.useTabsModel);
        return react_1.default.createElement(exports.TabsModelContext.Provider, { value: value }, children);
    },
    subComponents: {
        List: TabList_1.TabList,
        Item: Tab_1.Tab,
        Panel: TabPanel_1.TabPanel,
    },
});
