"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var canvas_kit_react_common_1 = require("@workday/canvas-kit-react-common");
var useCursorModel_1 = require("./useCursorModel");
exports.orientationKeyMap = {
    horizontal: {
        ArrowLeft: 'previous',
        Left: 'previous',
        ArrowRight: 'next',
        Right: 'next',
        Home: 'first',
        End: 'last',
    },
    vertical: {
        ArrowUp: 'previous',
        Up: 'previous',
        ArrowDown: 'next',
        Down: 'next',
        Home: 'first',
        End: 'last',
    },
};
var rightToLeftMap = {
    ArrowLeft: 'ArrowRight',
    Left: 'Right',
    ArrowRight: 'ArrowLeft',
    Right: 'Left',
    Home: 'End',
    End: 'Home',
};
exports.useRovingFocus = function (_a, elemProps) {
    var state = _a.state, events = _a.events;
    if (elemProps === void 0) { elemProps = {}; }
    var focusRef = react_1.default.useRef(false);
    var isRTL = canvas_kit_react_common_1.useIsRTL();
    react_1.default.useEffect(function () {
        var _a;
        if (focusRef.current) {
            var item = useCursorModel_1.getItem(state.cursorId, state.items);
            (_a = item.ref.current) === null || _a === void 0 ? void 0 : _a.focus();
            focusRef.current = false;
        }
    }, [state.cursorId, state.items]);
    return canvas_kit_react_common_1.mergeProps({
        onKeyDown: function (event) {
            Object.keys(exports.orientationKeyMap[state.orientation]).forEach(function (key) {
                var _a;
                if (isRTL ? event.key === rightToLeftMap[key] : event.key === key) {
                    var event_1 = exports.orientationKeyMap[state.orientation][key];
                    focusRef.current = true;
                    (_a = events[event_1]) === null || _a === void 0 ? void 0 : _a.call(events);
                }
            });
        },
    }, elemProps);
};
