"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var canvas_kit_react_common_1 = require("@workday/canvas-kit-react-common");
var hooks_1 = require("./cursor/hooks");
exports.useResetCursorOnBlur = function (_a, elemProps) {
    var state = _a.state, events = _a.events;
    if (elemProps === void 0) { elemProps = {}; }
    var programmaticFocusRef = react_1.default.useRef(false);
    return canvas_kit_react_common_1.mergeProps({
        onKeyDown: function (event) {
            if (Object.keys(hooks_1.orientationKeyMap[state.orientation]).indexOf(event.key) !== -1) {
                programmaticFocusRef.current = true;
            }
        },
        onFocus: function () {
            programmaticFocusRef.current = false;
        },
        onBlur: function () {
            if (!programmaticFocusRef.current) {
                events.goTo({ id: state.activeTab });
            }
        },
    }, elemProps);
};
