import React from 'react';
import { Model, ToModelConfig } from '@workday/canvas-kit-react-common';
export declare type Item = {
    id: string;
    ref: React.RefObject<HTMLElement>;
};
export declare type ListState = {
    id: string;
    indexRef: React.RefObject<number>;
    items: Item[];
};
export declare type ListEvents = {
    registerItem(data: {
        item: Item;
    }): void;
    unregisterItem(data: {
        id: string;
    }): void;
};
export declare type ListModel = Model<ListState, ListEvents>;
export declare const listEventMap: {
    guards: {
        shouldRegisterItem: "registerItem";
        shouldUnregisterItem: "unregisterItem";
    };
    callbacks: {
        onRegisterItem: "registerItem";
        onUnregisterItem: "unregisterItem";
    };
};
export declare type BaseListModelConfig = {
    id?: string;
};
export declare type ListModelConfig = BaseListModelConfig & Partial<ToModelConfig<ListState, ListEvents, typeof listEventMap>>;
export declare const useListModel: (config?: ListModelConfig) => Model<ListState, ListEvents>;
//# sourceMappingURL=useListModel.d.ts.map