"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var canvas_kit_react_common_1 = require("@workday/canvas-kit-react-common");
exports.listEventMap = canvas_kit_react_common_1.createEventMap()({
    guards: {
        shouldRegisterItem: 'registerItem',
        shouldUnregisterItem: 'unregisterItem',
    },
    callbacks: {
        onRegisterItem: 'registerItem',
        onUnregisterItem: 'unregisterItem',
    },
});
exports.useListModel = function (config) {
    if (config === void 0) { config = {}; }
    var id = canvas_kit_react_common_1.useUniqueId(config.id);
    var indexRef = react_1.default.useRef(0);
    var _a = react_1.default.useState([]), items = _a[0], setItems = _a[1];
    var state = { id: id, items: items, indexRef: indexRef };
    var events = canvas_kit_react_common_1.useEventMap(exports.listEventMap, state, config, {
        registerItem: function (_a) {
            var item = _a.item;
            indexRef.current++;
            setItems(function (items) { return items.concat(item); });
        },
        unregisterItem: function (_a) {
            var id = _a.id;
            setItems(function (items) { return items.filter(function (item) { return item.id !== id; }); });
        },
    });
    return { state: state, events: events };
};
