"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var canvas_kit_react_common_1 = require("@workday/canvas-kit-react-common");
var useCursorModel_1 = require("./cursor/useCursorModel");
var useListModel_1 = require("./list/useListModel");
exports.tabEventMap = canvas_kit_react_common_1.createEventMap()({
    guards: __assign(__assign({}, useCursorModel_1.cursorEventMap.guards), { shouldActivate: 'activate' }),
    callbacks: __assign(__assign({}, useCursorModel_1.cursorEventMap.callbacks), { onActivate: 'activate' }),
});
exports.useTabsModel = function (config) {
    if (config === void 0) { config = {}; }
    var initialTabRef = react_1.default.useRef(config.initialTab);
    var _a = react_1.default.useState(initialTabRef.current || ''), activeTab = _a[0], setActiveTab = _a[1];
    var menu = useCursorModel_1.useCursorModel(__assign(__assign({ orientation: config.orientation || 'horizontal' }, config), { onRegisterItem: function (_a) {
            var data = _a.data, state = _a.state;
            var _b;
            if (!initialTabRef.current) {
                initialTabRef.current = data.item.id;
                setActiveTab(initialTabRef.current);
            }
            (_b = config.onRegisterItem) === null || _b === void 0 ? void 0 : _b.call(config, { data: data, state: state });
        } }));
    var panels = useListModel_1.useListModel();
    var state = __assign(__assign({}, menu.state), { activeTab: activeTab, panels: panels.state.items, panelIndexRef: panels.state.indexRef });
    var events = canvas_kit_react_common_1.useEventMap(exports.tabEventMap, state, config, __assign(__assign({}, menu.events), { activate: function (data) {
            setActiveTab(data.tab);
            events.goTo({ id: data.tab });
        }, registerPanel: panels.events.registerItem, unregisterPanel: panels.events.unregisterItem }));
    return {
        state: state,
        events: events,
    };
};
