var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { colors, spacing, type, borderRadius } from '@workday/canvas-kit-react-core';
import { createComponent, focusRing, hideMouseFocus, mergeProps, styled, useLocalRef, useModelContext, } from '@workday/canvas-kit-react-common';
import { TabsModelContext } from './Tabs';
import { useRegisterItem } from './list';
var StyledButton = styled('button')(__assign(__assign(__assign(__assign(__assign({}, type.body), type.variant.button), { border: 'none', backgroundColor: 'transparent', flex: '0 0 auto', maxWidth: '280px', padding: spacing.s, boxSizing: 'border-box', cursor: 'pointer', color: colors.licorice300, position: 'relative', marginLeft: "" + spacing.xxxs, borderRadius: borderRadius.m + " " + borderRadius.m + " 0px 0px", transition: 'background 150ms ease, color 150ms ease', '&:first-of-type': {
        marginLeft: 0,
    } }), hideMouseFocus), { '&:hover, &:focus': {
        backgroundColor: colors.soap200,
        color: colors.blackPepper400,
    }, '&:focus': __assign({ outline: "none" }, focusRing({ inset: 'outer', width: 0, separation: 2 })), '&:disabled': {
        color: colors.licorice100,
        '&:hover': {
            cursor: 'auto',
            backgroundColor: "transparent",
        },
    } }), function (_a) {
    var isSelected = _a.isSelected;
    if (isSelected) {
        return {
            color: colors.blueberry400,
            cursor: 'default',
            '&:after': {
                position: 'absolute',
                height: spacing.xxxs,
                borderRadius: borderRadius.m + " " + borderRadius.m + " 0px 0px",
                backgroundColor: colors.blueberry400,
                bottom: 0,
                content: "''",
                left: 0,
                marginTop: '-2px',
                width: '100%',
            },
            '&:hover, &:focus': {
                backgroundColor: "transparent",
                color: colors.blueberry400,
            },
        };
    }
    return {};
});
export var Tab = createComponent('button')({
    displayName: 'Tabs.Item',
    Component: function (_a, ref, Element) {
        var _b = _a.name, name = _b === void 0 ? '' : _b, model = _a.model, children = _a.children, elemProps = __rest(_a, ["name", "model", "children"]);
        var _c = useLocalRef(ref), localRef = _c.localRef, elementRef = _c.elementRef;
        var _d = useModelContext(TabsModelContext, model), state = _d.state, events = _d.events;
        var tabName = useRegisterItem({ state: state, events: events }, localRef, name);
        var onSelect = function () {
            events.activate({ tab: tabName });
        };
        var isSelected = !!tabName && state.activeTab === tabName;
        var props = mergeProps({
            id: "tab-" + state.id + "-" + tabName,
            tabIndex: !!tabName && state.cursorId === tabName ? undefined : -1,
            'aria-selected': isSelected ? true : undefined,
            'aria-controls': "tabpanel-" + state.id + "-" + tabName,
            onClick: onSelect,
            isSelected: isSelected,
        }, elemProps);
        return (React.createElement(StyledButton, __assign({ type: "button", role: "tab", ref: elementRef, as: Element }, props), children));
    },
});
