var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { spacing, commonColors } from '@workday/canvas-kit-react-core';
import { composeHooks, createComponent, styled, useModelContext, } from '@workday/canvas-kit-react-common';
import { useRovingFocus } from './cursor/hooks';
import { TabsModelContext } from './Tabs';
import { useResetCursorOnBlur } from './hooks';
var TabsListContainer = styled('div')({
    display: 'inline-block',
    position: 'relative',
    width: "100%",
    borderBottom: "1px solid " + commonColors.divider,
});
var TabsListInnerContainer = styled('div')({
    display: "flex",
    margin: "0 " + spacing.m,
});
export var TabList = createComponent('div')({
    displayName: 'Tabs.List',
    Component: function (_a, ref, Element) {
        var children = _a.children, model = _a.model, elemProps = __rest(_a, ["children", "model"]);
        var _b = useModelContext(TabsModelContext, model), state = _b.state, events = _b.events;
        var props = composeHooks(useRovingFocus, useResetCursorOnBlur)({ state: state, events: events }, elemProps);
        return (React.createElement(TabsListContainer, null,
            React.createElement(TabsListInnerContainer, __assign({ as: Element, ref: ref, role: "tablist" }, props), children)));
    },
});
