var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { jsx, css } from '@emotion/core';
import { createComponent, mouseFocusBehavior, useLocalRef, useModelContext, useMountLayout, } from '@workday/canvas-kit-react-common';
import { TabsModelContext } from './Tabs';
var styles = css(mouseFocusBehavior({
    '&:focus': {
        outline: 'none',
    },
}));
export var TabPanel = createComponent('div')({
    displayName: 'Tabs.Panel',
    Component: function (_a, ref, Element) {
        var children = _a.children, _b = _a.name, name = _b === void 0 ? '' : _b, model = _a.model, elemProps = __rest(_a, ["children", "name", "model"]);
        var _c = useModelContext(TabsModelContext, model), state = _c.state, events = _c.events;
        var _d = React.useState(name), tabName = _d[0], setTabName = _d[1];
        var _e = useLocalRef(ref), localRef = _e.localRef, elementRef = _e.elementRef;
        useMountLayout(function () {
            var index = state.panelIndexRef.current;
            var tabName = name || String(index);
            events.registerPanel({ item: { id: tabName, ref: localRef } });
            setTabName(tabName);
            return function () {
                events.unregisterItem({ id: tabName });
            };
        });
        return (jsx(Element, __assign({ ref: elementRef, role: "tabpanel", css: styles, "aria-labelledby": "tab-" + state.id + "-" + tabName, hidden: !!tabName && tabName !== state.activeTab, id: "tabpanel-" + state.id + "-" + tabName, tabIndex: 0 }, elemProps), children));
    },
});
