var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { createComponent, useDefaultModel } from '@workday/canvas-kit-react-common';
import { Tab } from './Tab';
import { TabList } from './TabList';
import { TabPanel } from './TabPanel';
import { useTabsModel } from './useTabsModel';
export var TabsModelContext = React.createContext({});
export var Tabs = createComponent()({
    displayName: 'Tabs',
    Component: function (_a) {
        var children = _a.children, model = _a.model, config = __rest(_a, ["children", "model"]);
        var value = useDefaultModel(model, config, useTabsModel);
        return React.createElement(TabsModelContext.Provider, { value: value }, children);
    },
    subComponents: {
        List: TabList,
        Item: Tab,
        Panel: TabPanel,
    },
});
