import React from 'react';
import { mergeProps, useIsRTL } from '@workday/canvas-kit-react-common';
import { getItem } from './useCursorModel';
export var orientationKeyMap = {
    horizontal: {
        ArrowLeft: 'previous',
        Left: 'previous',
        ArrowRight: 'next',
        Right: 'next',
        Home: 'first',
        End: 'last',
    },
    vertical: {
        ArrowUp: 'previous',
        Up: 'previous',
        ArrowDown: 'next',
        Down: 'next',
        Home: 'first',
        End: 'last',
    },
};
var rightToLeftMap = {
    ArrowLeft: 'ArrowRight',
    Left: 'Right',
    ArrowRight: 'ArrowLeft',
    Right: 'Left',
    Home: 'End',
    End: 'Home',
};
export var useRovingFocus = function (_a, elemProps) {
    var state = _a.state, events = _a.events;
    if (elemProps === void 0) { elemProps = {}; }
    var focusRef = React.useRef(false);
    var isRTL = useIsRTL();
    React.useEffect(function () {
        var _a;
        if (focusRef.current) {
            var item = getItem(state.cursorId, state.items);
            (_a = item.ref.current) === null || _a === void 0 ? void 0 : _a.focus();
            focusRef.current = false;
        }
    }, [state.cursorId, state.items]);
    return mergeProps({
        onKeyDown: function (event) {
            Object.keys(orientationKeyMap[state.orientation]).forEach(function (key) {
                var _a;
                if (isRTL ? event.key === rightToLeftMap[key] : event.key === key) {
                    var event_1 = orientationKeyMap[state.orientation][key];
                    focusRef.current = true;
                    (_a = events[event_1]) === null || _a === void 0 ? void 0 : _a.call(events);
                }
            });
        },
    }, elemProps);
};
