import { Model, ToModelConfig } from '@workday/canvas-kit-react-common';
import { ListState, ListEvents, BaseListModelConfig, Item } from '../list/useListModel';
export declare type Orientation = 'horizontal' | 'vertical';
export declare type CursorState = ListState & {
    orientation: Orientation;
    cursorId: string;
};
export declare type CursorEvents = ListEvents & {
    goTo(data: {
        id: string;
    }): void;
    next(): void;
    previous(): void;
    first(): void;
    last(): void;
};
export declare type CursorModel = Model<CursorState, CursorEvents>;
export declare const cursorEventMap: {
    guards: {
        shouldGoTo: "goTo";
        shouldRegisterItem: "registerItem";
        shouldUnregisterItem: "unregisterItem";
    };
    callbacks: {
        onGoTo: "goTo";
        onRegisterItem: "registerItem";
        onUnregisterItem: "unregisterItem";
    };
};
export declare type BaseCursorModelConfig = BaseListModelConfig & {
    orientation?: Orientation;
};
export declare type CursorModelConfig = BaseCursorModelConfig & Partial<ToModelConfig<CursorState, CursorEvents, typeof cursorEventMap>>;
export declare const getItem: (id: string, items: Item[]) => Item;
export declare const useCursorModel: (config?: CursorModelConfig) => Model<CursorState, CursorEvents>;
//# sourceMappingURL=useCursorModel.d.ts.map