import React from 'react';
import { mergeProps } from '@workday/canvas-kit-react-common';
import { orientationKeyMap } from './cursor/hooks';
export var useResetCursorOnBlur = function (_a, elemProps) {
    var state = _a.state, events = _a.events;
    if (elemProps === void 0) { elemProps = {}; }
    var programmaticFocusRef = React.useRef(false);
    return mergeProps({
        onKeyDown: function (event) {
            if (Object.keys(orientationKeyMap[state.orientation]).indexOf(event.key) !== -1) {
                programmaticFocusRef.current = true;
            }
        },
        onFocus: function () {
            programmaticFocusRef.current = false;
        },
        onBlur: function () {
            if (!programmaticFocusRef.current) {
                events.goTo({ id: state.activeTab });
            }
        },
    }, elemProps);
};
