import React from 'react';
import { createEventMap, useEventMap, useUniqueId, } from '@workday/canvas-kit-react-common';
export var listEventMap = createEventMap()({
    guards: {
        shouldRegisterItem: 'registerItem',
        shouldUnregisterItem: 'unregisterItem',
    },
    callbacks: {
        onRegisterItem: 'registerItem',
        onUnregisterItem: 'unregisterItem',
    },
});
export var useListModel = function (config) {
    if (config === void 0) { config = {}; }
    var id = useUniqueId(config.id);
    var indexRef = React.useRef(0);
    var _a = React.useState([]), items = _a[0], setItems = _a[1];
    var state = { id: id, items: items, indexRef: indexRef };
    var events = useEventMap(listEventMap, state, config, {
        registerItem: function (_a) {
            var item = _a.item;
            indexRef.current++;
            setItems(function (items) { return items.concat(item); });
        },
        unregisterItem: function (_a) {
            var id = _a.id;
            setItems(function (items) { return items.filter(function (item) { return item.id !== id; }); });
        },
    });
    return { state: state, events: events };
};
