var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { createEventMap, useEventMap } from '@workday/canvas-kit-react-common';
import { cursorEventMap, useCursorModel, } from './cursor/useCursorModel';
import { useListModel } from './list/useListModel';
export var tabEventMap = createEventMap()({
    guards: __assign(__assign({}, cursorEventMap.guards), { shouldActivate: 'activate' }),
    callbacks: __assign(__assign({}, cursorEventMap.callbacks), { onActivate: 'activate' }),
});
export var useTabsModel = function (config) {
    if (config === void 0) { config = {}; }
    var initialTabRef = React.useRef(config.initialTab);
    var _a = React.useState(initialTabRef.current || ''), activeTab = _a[0], setActiveTab = _a[1];
    var menu = useCursorModel(__assign(__assign({ orientation: config.orientation || 'horizontal' }, config), { onRegisterItem: function (_a) {
            var data = _a.data, state = _a.state;
            var _b;
            if (!initialTabRef.current) {
                initialTabRef.current = data.item.id;
                setActiveTab(initialTabRef.current);
            }
            (_b = config.onRegisterItem) === null || _b === void 0 ? void 0 : _b.call(config, { data: data, state: state });
        } }));
    var panels = useListModel();
    var state = __assign(__assign({}, menu.state), { activeTab: activeTab, panels: panels.state.items, panelIndexRef: panels.state.indexRef });
    var events = useEventMap(tabEventMap, state, config, __assign(__assign({}, menu.events), { activate: function (data) {
            setActiveTab(data.tab);
            events.goTo({ id: data.tab });
        }, registerPanel: panels.events.registerItem, unregisterPanel: panels.events.unregisterItem }));
    return {
        state: state,
        events: events,
    };
};
